const path = require('path');
const glob = require('glob');

global.gulp = require('gulp');
global.gulpSequence = require('gulp-sequence');

const UTILS_PATH = path.join(__dirname, './utils/**/*.js');
const GULP_TASKS = path.join(__dirname, './**/*.js');

let utils = glob.sync(UTILS_PATH);
let ignore = [ 
  path.join(__dirname, './index.js')
].concat(utils);

const gulpAngular = {
  tasks: glob.sync(GULP_TASKS, { dot: true, ignore: ignore }),
  getTaskNames: () => {
    let names = [], paths = [];
    gulpAngular.tasks.forEach((task) => {
      let name = path.basename(task);
      names.push(name.replace('-', ':'));
      paths.push(task);
    });
    return {
      names: names,
      paths: paths
    };
  },
  addOrOverrideTasks: (taskFiles) => {
    let overrideTasks = [];
    taskFiles.forEach((taskFile) => {
      let tasks = gulpAngular.tasks.filter((task) => {
        return path.basename(task) === path.basename(taskFile);
      });
      if (tasks && tasks.length > 0){
        overrideTasks.push(tasks[0]);
      }
      gulpAngular.tasks.push(taskFile);
    });
    overrideTasks.forEach((task) => {
      let index = gulpAngular.tasks.indexOf(task);
      gulpAngular.tasks.splice(index, 1);
    });
  }
};

exports.gulpAngular = gulpAngular;